zoukankan      html  css  js  c++  java
  • Codeforces Round #596 (Div. 2, based on Technocup 2020 Elimination Round 2) E. Rock Is Push dp

    E. Rock Is Push

    You are at the top left cell (1,1) of an n×m labyrinth. Your goal is to get to the bottom right cell (n,m). You can only move right or down, one cell per step. Moving right from a cell (x,y) takes you to the cell (x,y+1), while moving down takes you to the cell (x+1,y).

    Some cells of the labyrinth contain rocks. When you move to a cell with rock, the rock is pushed to the next cell in the direction you're moving. If the next cell contains a rock, it gets pushed further, and so on.

    The labyrinth is surrounded by impenetrable walls, thus any move that would put you or any rock outside of the labyrinth is illegal.

    Count the number of different legal paths you can take from the start to the goal modulo 109+7. Two paths are considered different if there is at least one cell that is visited in one path, but not visited in the other.

    Input

    The first line contains two integers n,m — dimensions of the labyrinth (1≤n,m≤2000).

    Next n lines describe the labyrinth. Each of these lines contains m characters. The j-th character of the i-th of these lines is equal to "R" if the cell (i,j) contains a rock, or "." if the cell (i,j) is empty.

    It is guaranteed that the starting cell (1,1) is empty.

    Output

    Print a single integer — the number of different legal paths from (1,1) to (n,m) modulo 109+7.

    Examples

    input
    1 1
    .
    output
    1
    input
    2 3
    ...
    ..R
    output
    0
    input
    4 4
    ...R
    .RR.
    .RR.
    R...
    output
    4

    Note

    In the first sample case we can't (and don't have to) move, hence the only path consists of a single cell (1,1).

    In the second sample case the goal is blocked and is unreachable.

    Illustrations for the third sample case can be found here: https://subdomain.codeforc.es/menci/assets/rounds/1225/index.html

    题意

    一个n*m的矩阵,里面有一堆箱子,你可以推箱子,连续的箱子你也能推动。

    问你从(1,1)到(n,m)有多少种不同路径的方案个数。

    题解

    定义:
    dp[i][j][0]表示从(i,j)往下走到达终点的方案数。
    dp[i][j][1]表示从(i,j)往右走到达终点的方案数。

    比较显然的
    dp[i][j][0]=dp[i+1][j][1]+dp[i+2][j][1]+....+dp[i+x][j][1],直到(i+x+1,j)是一个箱子推到底了,不能再推箱子了。

    同理dp[i][j][1]也是如此。

    显然后面这坨可以用前缀和优化一下,然后就可以变成n^2的dp转移了。

    代码

    #include<bits/stdc++.h>
    using namespace std;
    const int maxn = 2005;
    int n,m;
    const int mod = 1e9+7;
    char a[maxn][maxn];
    // 0 for down;1 for right
    int num[maxn][maxn][2],dp[maxn][maxn][2],sum[maxn][maxn][2];
    int main(){
    	scanf("%d%d",&n,&m);
    	for(int i=1;i<=n;i++){
    		scanf("%s",a[i]+1);
    	}
    	if(n==1&&m==1&&a[1][1]=='.'){
    		cout<<"1"<<endl;
    		return 0;
    	}
    	if(a[1][1]=='R'||a[n][m]=='R'){
    		cout<<"0"<<endl;
    		return 0;
    	}
    	for(int i=n;i>=1;i--){
    		for(int j=m;j>=1;j--){
    			if(a[i][j]=='R'){
    				num[i][j][0]+=1;
    				num[i][j][1]+=1;
    			}
    			num[i][j][0]+=num[i+1][j][0];
    			num[i][j][1]+=num[i][j+1][1];
    		}
    	}
    	dp[n][m][0]=1;dp[n][m][1]=1;sum[n][m][0]=1;sum[n][m][1]=1;
    	for(int i=n;i>=1;i--){
    		for(int j=m;j>=1;j--){
    			if(i==n&&j==m)continue;
    			dp[i][j][0]=(sum[i+1][j][0]-sum[n-num[i+1][j][0]+1][j][0])%mod;
    			dp[i][j][1]=(sum[i][j+1][1]-sum[i][m-num[i][j+1][1]+1][1])%mod;
    			sum[i][j][0]=(sum[i+1][j][0]+dp[i][j][1])%mod;
    			sum[i][j][1]=(sum[i][j+1][1]+dp[i][j][0])%mod;
    		}
    	}
    	cout<<(dp[1][1][0]+dp[1][1][1]+2ll*mod)%mod<<endl;
    }
  • 相关阅读:
    Leetcode143. Reorder List重排链表
    Leetcode93. Restore IP Addresses复原IP地址
    Leetcode92. Reverse Linked List II反转链表
    Leetcode970. Powerful Integers强整数
    Leetcode931. Minimum Falling Path Sum下降路径最小和
    2019个人计划与Flag与期望
    排查问题-查看日志的正确打开方式
    Vuex-状态管理模式
    Git 常用操作(二)
    Hive:HQL和Mysql:SQL 的区别
  • 原文地址:https://www.cnblogs.com/qscqesze/p/11782207.html
Copyright © 2011-2022 走看看